#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vvi = vector<vi>;

#define f(i,a,b) for(int i = (a); i < (b); i++)
#define rep(i,a,b) for(int i = (a); i < (b); i++)
#define pb emplace_back
#define PB push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define dump(x) cout << #x << "=" << x << endl;


const ll mod = 10e9 + 7;
struct Mod {
	ll x;
	Mod(ll xx): x(xx) {}
	Mod operator+ (Mod b) {return Mod((x  + b.x) % mod);}
	Mod operator- (Mod b) {return Mod((x  - b.x + mod) % mod);}
	Mod operator* (Mod b) {return Mod((x  * b.x) % mod);}
};
template<class T, int N> struct Matrix {
	typedef Matrix M;
	vector<vector<T>> d (N, vector<T>(N, T(0)));
	M operator *(const M& m) const {
		M a;
		rep (i,0,N) rep(j,0,N)
			rep(k,0,N) a.d[i][j] = a.d[i][j] + d[i][k]*m.d[k][j];
		return a;
	}
	vector<T> operator* (const vector<T> &vec) const {
		vector<T> ret(N);
		rep(i,0,N) rep(j,0,N) ret[i] = ret[i] +  d[i][j] * vec[j];
		return ret;
	}
	M operator ^(ll p) const {
		M a, b (*this);
		rep (i, 0, N) a.d[i][i] = 1;
		while (p) {
			if (p&1) a = a * b;
			b = b  * b;
			p>>=1;
		}
		return a;
	}
};

void mul(vvi &res, vvi &a, vvi &b, int n)
{
	f(i,0,n)
		f(j,0,n)
		{
			f(k,0,n)
			{
				res[i][j] += a[i][k] * b[j][k];
				res[i][j] = res[i][j] %mod;
			}
		}
}

void power(vvi &a, int e, int n)
{
		vvi c(n, vi(n, 0));
		f(i,0,n)
			f(j,0,n)
			c[i][j] = a[i][j];
		while (p) {
			if (p&1) mul(b,b,a n);
			b = b  * b;
			p>>=1;
		}
		return a;

}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	const int kk = 67;
	int k; ll n;
	cin >> k >> n;

	vector<Mod> vals (kk, Mod(0));
	f(i,0,k) vals[i] = Mod(1);
	vector<vector<Mod>> Aa (kk, vector<Mod>(kk, Mod(0)));
	
	f(i,0,k)
	{
		f(j,0,k)
		{
			int ii = i+1;
			int jj = j+1;
			int gcd = __gcd(ii, jj);
			int should = gcd == 1;
			Aa[i][j] = should;
		}
	}

	Matrix<Mod, kk> A;
	A.d = Aa;

	if (n > 1)
	{
		Matrix<Mod, kk> B = A ^ (n-1);
		vals = B * vals;
	}

	Mod ans = Mod(0);

	f(i,0,k)
	{
		ans = ans  +  vals[i];
	}
	cout << ans.x << "\n";



	return 0;
}
